﻿using UnityEngine;
using System;
using System.Net;
using System.Collections.Generic;
using uPLibrary.Networking.M2Mqtt;
using uPLibrary.Networking.M2Mqtt.Messages;
using UnityEngine.UI;

public class mqttShiftrIO : MonoBehaviour
{
    private MqttClient client;

    //COLOR-1
    int red1;
    int green1;
    int blue1;
    //color-2
    string red2;
    string green2;
    string blue2;

    //mixcolor
    int MixRed;
    int MixGreen;
    int MixBlue;


    //color轉存string
    string Red;
    string Green;
    string Blue;
    //all color to shiftr io
    public string color;


    public string Shiftrio_ClientID = "";    //  Client ID
    public string Shiftrio_Key = "";     //   instance name
    public string Shiftrio_Secret = "";     //  access token

    public string msg = "";

    public List<string> topics_sub = new List<string>();

    //buttom 陣列
    public GameObject[] objects;
    //陣列數字
    int i = 0;



    void Start()
    {
        // create client instance
        client = new MqttClient(IPAddress.Parse("34.77.13.55"), 1883, false, null); ////////"34.76.6.166" ---> IP from boker.shiftr.io

        // register to message received ---> EventSystem
        client.MqttMsgPublishReceived += client_MqttMsgPublishReceived;

        client.Connect(Shiftrio_ClientID, Shiftrio_Key, Shiftrio_Secret);

        // subscribe to the topics in the list with QoS 2 
        foreach (String topic in topics_sub)
        {
            client.Subscribe(new string[] { topic }, new byte[] { MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE });
        }

        Debug.Log(color);
    }

    public void client_MqttMsgPublishReceived(object sender, MqttMsgPublishEventArgs e)
    {
        //抓取MQTT的值
        string topic = e.Topic;
        msg = System.Text.Encoding.UTF8.GetString(e.Message);
        Debug.Log("Received: " + topic + " --> " + msg);

        string Red = (char)msg[0] + "" + (char)msg[1] + "" + (char)msg[2];
        red1 = Int32.Parse(Red);
        string Green = (char)msg[4] + "" + (char)msg[5] + "" + (char)msg[6];
        green1 = Int32.Parse(Green);
        string Blue = (char)msg[8] + "" + (char)msg[9] + "" + (char)msg[10];
        blue1 = Int32.Parse(Blue);
        Debug.Log(Red);
        Debug.Log(Green);
        Debug.Log(Blue);




    }

    public void RedButtom()
    {
        //控制red以選走按鈕遮罩

        //控制兩個混色
        MixRed = (red1 + 255) / 2;
        red2 = MixRed.ToString();
        MixGreen = (green1 + 0) / 2;
        green2 = MixGreen.ToString();
        MixBlue = (blue1 + 0) / 2;
        blue2 = MixBlue.ToString();

        //轉換成字串在shift io
        color = red2 + "," + green2 + "," + blue2;

        //publish 
        client.Publish("Unity01/", System.Text.Encoding.UTF8.GetBytes(color), MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE, true);
        Debug.Log(color);

        //按鈕顯示
        objects[i].SetActive(true);
        objects[i].gameObject.GetComponent<Image>().color = new Color32((byte)MixRed, (byte)MixGreen, (byte)MixBlue, 255);
        i += 1;


    }

    public void GreenButtom()
    {
        //控制green藍色以選走按鈕遮罩

        MixRed = (red1 + 0) / 2;
        red2 = MixRed.ToString();
        MixGreen = (green1 + 255) / 2;
        green2 = MixGreen.ToString();
        MixBlue = (blue1 + 0) / 2;
        blue2 = MixBlue.ToString();

        //轉換成字串在shift io
        color = red2 + "," + green2 + "," + blue2;

        //publish 
        client.Publish("Unity01/", System.Text.Encoding.UTF8.GetBytes(color), MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE, true);
        Debug.Log(color);

        //按鈕顯示
        objects[i].SetActive(true);
        objects[i].gameObject.GetComponent<Image>().color = new Color32((byte)MixRed, (byte)MixGreen, (byte)MixBlue, 255);
        i += 1;
    }

    public void Buttom()
    {
        //其他按鈕遮罩
        Debug.Log(23333333);
        Debug.Log(Remap(objects[i].gameObject.GetComponent<Image>().color.r));
        Debug.Log(Remap(objects[i].gameObject.GetComponent<Image>().color.g));
        Debug.Log(Remap(objects[i].gameObject.GetComponent<Image>().color.b));

        MixRed = (red1 +(int) Remap(objects[i].gameObject.GetComponent<Image>().color.r))/ 2;
        red2 = MixRed.ToString();
        MixGreen = (green1 + (int)Remap(objects[i].gameObject.GetComponent<Image>().color.g)) / 2;
        green2 = MixGreen.ToString();
        MixBlue = (blue1 + (int)Remap(objects[i].gameObject.GetComponent<Image>().color.b) )/ 2;
        blue2 = MixBlue.ToString();

        //轉換成字串在shift io
        color = red2 + "," + green2 + "," + blue2;


        Debug.Log(MixRed);
        Debug.Log(MixGreen);
        Debug.Log(MixBlue);
        //publish 
        client.Publish("Unity01/", System.Text.Encoding.UTF8.GetBytes(color), MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE, true);
        Debug.Log(color);

        //按鈕顯示
        objects[i].SetActive(true);
        objects[i].gameObject.GetComponent<Image>().color = new Color32((byte)MixRed, (byte)MixGreen, (byte)MixBlue, 255);
        i += 1;
    }

    public void BlueButtom()
    {
        //控制藍色以選走按鈕遮罩

        MixRed = (red1 + 0) / 2;
        red2 = MixRed.ToString();
        MixGreen = (green1 + 0) / 2;
        green2 = MixGreen.ToString();
        MixBlue = (blue1 + 255) / 2;
        blue2 = MixBlue.ToString();

        //轉換成字串在shift io
        color = red2 + "," + green2 + "," + blue2;

        //publish 
        client.Publish("Unity01/", System.Text.Encoding.UTF8.GetBytes(color), MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE, true);
        Debug.Log(color);

        //按鈕顯示
        objects[i].SetActive(true);
        objects[i].gameObject.GetComponent<Image>().color = new Color32((byte)MixRed, (byte)MixGreen, (byte)MixBlue, 255);
        i += 1;
    }

    float Remap(float value)
    {
        float fromAbs = value - 0;
        float fromMaxAbs = 1 - 0;
        float normal = fromAbs / fromMaxAbs;
        float toMaxAbs = 255 - 0;
        float toAbs = toMaxAbs * normal;
        float to = toAbs + 0;

        return to;
    }
}
